/*-
 * Copyright (c) 1993
 *      The Regents of the University of California.  All rights reserved.
 * MS-DOS Version B.Meiner, 2017 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <sys/cdefs.h>

#include <sys/param.h>
#include <sys/stat.h>

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void usage __P((void));
int main __P((int, char *[]));

int
main(argc, argv)
        int argc;
        char *argv[];
{
        struct stat sb;
        size_t len;
        int ch, sverrno, mib[2];
        char *p, *t, *std, path[MAXPATHLEN];

        while ((ch = getopt(argc, argv, "")) != -1)
                switch (ch) {
                case '?':
                default:
                        usage();
                }
        argc -= optind;
        argv += optind;

        if (argc == 0)
                usage();

        char * mypath  = getenv("PATH") ; 
        char pathstring[512] ;
        char pathstring1[512] ;
        char pathstring2[512] ;
        char pathstring3[512] ;
        char * p1a ; 
        char * p1b ; 
        char * p2a ;
        char * p2b ;
        char * p3a ;
        char * p3b ;
                          
         char ** res  = NULL;

         char *  q    = strtok (mypath, ";");       
         int n_spaces = 0, i;
         int j ;
         int le  ;

/* split string and append tokens to 'res' */

while (q) {
  res = realloc(res, sizeof (char*) * ++n_spaces + 2);

  if (res == NULL)
    exit (-1); /* memory allocation failed */

  res[n_spaces-1] = q;

  q = strtok (NULL, ";");
}
/* realloc one extra element for the last NULL */

   res = realloc (res, sizeof (char*) * (n_spaces+1) + 2 );
   res[n_spaces] = ".";
   res[n_spaces + 1] = 0;

     strcpy(pathstring,"");
     for(j=0;j<argc;j++) {

                              for (i = 0; i < (n_spaces+1); ++i) {
                              strcpy(pathstring,res[i]);
                              le  = strlen(pathstring) ;
                              if (le>0 && !(pathstring[le-1] == 0x5c)) {
                              strcat(pathstring,"\\") ;                }
                              strcat(pathstring,argv[j]);

                              p1a = strstr(pathstring,".exe")    ;
                              p1b = strstr(pathstring,".EXE")    ;
                              p2a = strstr(pathstring,".com")    ;
                              p2b = strstr(pathstring,".COM")    ;
                              p3a = strstr(pathstring,".bat")    ;
                              p3b = strstr(pathstring,".BAT")    ;


                              if   ( p1a || p1b || p2a || p2b || p3a ||p3b ) {
                              if (!stat(pathstring, &sb)) {
                                         printf("%s \n",pathstring);
                                                          }
                                                                             }
                              else {

                              strcpy(pathstring1,pathstring) ;
                              strcpy(pathstring2,pathstring) ;
                              strcpy(pathstring3,pathstring) ;
                              strcat(pathstring1,".bat")     ;
                              strcat(pathstring2,".com")     ;
                              strcat(pathstring3,".exe")     ;

                              if(!stat(pathstring1, &sb)) {
                                         printf("%s \n",pathstring1);
                                                          }
                              if(!stat(pathstring2, &sb)) {
                                         printf("%s \n",pathstring2);
                                                          }
                              if(!stat(pathstring3, &sb)) {
                                         printf("%s \n",pathstring3);
                                                          }
                                   }

                               }                        
                         }                                    

        return (0);
}

void
usage()
{


        (void)fprintf(stderr, "WHEREIS for FreeDOS\n"); 
        (void)fprintf(stderr, "(c) The Regents of the University of California (original), 1993\n");
        (void)fprintf(stderr, "(c) Burkhard Meissner (FreeDOS version), 2017-2020\n");
        (void)fprintf(stderr, "usage: whereis program [...]\n");
        (void)fprintf(stderr, "e.d.:  whereis ls.exe \n");
        (void)fprintf(stderr, "       whereis ls     \n");
        exit (1);
}
